import dayjs from 'dayjs';
import type { ValidationError } from './index.js';
import ValueObject from './index.js';
export default abstract class DateObject extends ValueObject<dayjs.ConfigType, dayjs.Dayjs, string> {
    protected fromInput(): string;
    protected toOutput(): dayjs.Dayjs;
    getErrors(name: string): ValidationError[] | undefined;
    compare(value: this): number;
}
