export type ValidationError = {
    name: string;
    error: string;
};
export default abstract class ValueObject<Input, Output, Inner = Output> {
    private readonly _input;
    private _setInner;
    private _inner?;
    private _setOutput;
    private _output?;
    constructor(_input: Input);
    protected abstract get symbol(): symbol;
    protected fromInput(): Inner;
    protected toOutput(): Output;
    protected get input(): Input;
    protected get inner(): Inner;
    get value(): Output;
    equals(value: this): boolean;
    abstract compare(value: this): number;
    abstract getErrors(name: string, prev?: ValueObject<Input, Output, Inner>): ValidationError[] | undefined;
    validate(name: string, prev?: ValueObject<Input, Output, Inner>): void | never;
}
