import type { ValidationError } from './index.js';
import ValueObject from './index.js';
export default abstract class Text extends ValueObject<number | string, string> {
    protected fromInput(): string;
    protected getValidationMinLength(): number | undefined;
    protected getValidationMaxLength(): number | undefined;
    getErrors(name: string): ValidationError[] | undefined;
    compare(value: this): number;
}
